clf
clear all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    PARAMETERS                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%cd 
 
d = 0.144;      %diameter            [m]
r = d/2;        %radius              [m]
l = 20*d;       %domain length         [-] 
T = 3;
LL = l
nr = 100;         %mesh size
Nc = 320;
nc = Nc/8;
g = 1;         %grading

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    COORDINATES                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

x(1) = 0;
y(1) = 0;

x(2) = l/T;
y(2) = 0;

x(3) = l - l/T;
y(3) = 0;

x(4) = l;
y(4) = 0;

x(5) = l;
y(5) = l/T;

x(6) = l;
y(6) = l - l/T;

x(7) = l;
y(7) = l;

x(8) = l/T;
y(8) = l;

x(9) = l - l/T;
y(9) = l;

x(10) = 0;
y(10) = l;

x(11) = 0;
y(11) = l - l/T;

x(12) = 0;
y(12) = l/T;

x(13) = l/T;
y(13) = l/T;

x(14) = l/T;
y(14) = l - l/T;

x(15) = l - l/T;
y(15) = l - l/T;

x(16) = l - l/T;
y(16) = l/T;

x(17) = l/2;
y(17) = l/2 - r;

x(18) = l/2 + r;
y(18) = l/2;

x(19) = l/2;
y(19) = l/2 + r;

x(20) = l/2 - r;
y(20) = l/2;
 
x(21) = l/2 - r*cos(pi/8);
y(21) = l/2 + r*sin(pi/8);

x(22) = l/2 - r*cos(pi/4);
y(22) = l/2 + r*sin(pi/4);

x(23) = l/2 - r*cos(3*pi/8);
y(23) = l/2 + r*sin(3*pi/8);

x(24) = l/2 + r*cos(3*pi/8);
y(24) = l/2 + r*sin(3*pi/8);

x(25) = l/2 + r*cos(pi/4);
y(25) = l/2 + r*sin(pi/4);

x(26) = l/2 + r*cos(pi/8);
y(26) = l/2 + r*sin(pi/8);

%%

x(27) = l/2 - r*cos(pi/8);
y(27) = l/2 - r*sin(pi/8);

x(28) = l/2 - r*cos(pi/4);
y(28) = l/2 - r*sin(pi/4);

x(29) = l/2 - r*cos(3*pi/8);
y(29) = l/2 - r*sin(3*pi/8);

x(30) = l/2 + r*cos(3*pi/8);
y(30) = l/2 - r*sin(3*pi/8);

x(31) = l/2 + r*cos(pi/4);
y(31) = l/2 - r*sin(pi/4);

x(32) = l/2 + r*cos(pi/8);
y(32) = l/2 - r*sin(pi/8);

x(33) = l/2;
y(33) = 0;

x(34) = l;
y(34) = l/2;

x(35) = l/2;
y(35) = l;

x(36) = 0;
y(36) = l/2;

R = r + sqrt((x(13)-x(28))^2 + (y(13)-y(28))^2);

x(37) = l/2 - R;
y(37) = l/2;

x(38) = l/2 - R*cos(pi/8);
y(38) = l/2 + R*sin(pi/8);

x(39) = l/2 - R*cos(3*pi/8);
y(39) = l/2 + R*sin(3*pi/8);

x(40) = l/2;
y(40) = l/2 + R;

x(41) = l/2 + R*cos(3*pi/8);
y(41) = l/2 + R*sin(3*pi/8);

x(42) = l/2 + R*cos(pi/8);
y(42) = l/2 + R*sin(pi/8);

x(43) = l/2 + R;
y(43) = l/2;

x(44) = l/2 + R*cos(pi/8);
y(44) = l/2 - R*sin(pi/8);

x(45) = l/2 + R*cos(3*pi/8);
y(45) = l/2 - R*sin(3*pi/8);

x(46) = l/2;
y(46) = l/2 - R;

x(47) = l/2 - R*cos(3*pi/8);
y(47) = l/2 - R*sin(3*pi/8);

x(48) = l/2 - R*cos(pi/8);
y(48) = l/2 - R*sin(pi/8);

x(49) = 0;
y(49) = 0;

x(50) = 0;
y(50) = 0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    FIGURE PLOT                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
figure(1)
scatter(x,y,'k')
% a = [0:length(x)-1]';
% b = num2str(a);
% c = cellstr(b);
% dx = 0.01;
% dy = dx;
% text(x+dx, y+dy, c);
axis equal
%grid on
    hold on
    xlim([-d 3])
    ylim([-d 3])

    
%Plot patches
   %%%%%%
    for i = 1:11
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
    end
         plot([x(12) x(1)], [y(12) y(1)],'b')

     plot([x(11) x(14)], [y(11) y(14)],'b')
     plot([x(14) x(8)], [y(14) y(8)],'b')
     plot([x(15) x(9)], [y(15) y(9)],'b')
     plot([x(15) x(6)], [y(15) y(6)],'b')
     plot([x(16) x(5)], [y(16) y(5)],'b')
     plot([x(16) x(3)], [y(16) y(3)],'b')
     plot([x(13) x(2)], [y(13) y(2)],'b')
     for i = 20:22
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
     end
    plot([x(23) x(19)], [y(23) y(19)],'b')
    plot([x(24) x(19)], [y(24) y(19)],'b')
    for i = 24:25
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
    end
    plot([x(26) x(18)], [y(26) y(18)],'b')
    plot([x(18) x(32)], [y(18) y(32)],'b')
    for i = 30:31
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
    end
        plot([x(17) x(30)], [y(17) y(30)],'b')
        plot([x(17) x(29)], [y(17) y(29)],'b')
     for i = 27:28
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
     end
       plot([x(20) x(27)], [y(20) y(27)],'b')
       plot([x(22) x(14)], [y(22) y(14)],'b')
       plot([x(28) x(13)], [y(28) y(13)],'b')
       plot([x(31) x(16)], [y(31) y(16)],'b')
        plot([x(25) x(15)], [y(25) y(15)],'b')
        plot([x(36) x(37)], [y(36) y(37)],'b')
        plot([x(37) x(48)], [y(37) y(48)],'b')
        plot([x(37) x(38)], [y(37) y(38)],'b')
        plot([x(38) x(14)], [y(38) y(14)],'b')
        plot([x(14) x(39)], [y(14) y(39)],'b')
        for i = 39:40
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
       end
      plot([x(41) x(15)], [y(41) y(15)],'b')
      plot([x(15) x(42)], [y(15) y(42)],'b')
     for i = 42:43
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
       end
      plot([x(44) x(16)], [y(44) y(16)],'b')
      plot([x(16) x(45)], [y(16) y(45)],'b')
      for i = 45:46
        plot([x(i) x(i+1)], [y(i) y(i+1)],'b')
      end
      plot([x(47) x(13)], [y(47) y(13)],'b')
      plot([x(13) x(48)], [y(13) y(48)],'b')
      plot([x(37) x(20)], [y(37) y(20)],'b')
      plot([x(40) x(19)], [y(40) y(19)],'b')
       plot([x(43) x(18)], [y(43) y(18)],'b')
       plot([x(46) x(17)], [y(46) y(17)],'b')
       plot([x(12) x(13)], [y(12) y(13)],'b')
       plot([x(33) x(46)], [y(33) y(46)],'b')
       plot([x(35) x(40)], [y(35) y(40)],'b')
       plot([x(34) x(43)], [y(34) y(43)],'b')


%     %%%%%


coord = [x; y];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             WRITE TO blockMeshDict                 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

fileID = fopen('Wave_test/system/blockMeshDict.c','w');
fprintf(fileID,'/*--------------------------------*- C++ -*----------------------------------*\\ \n'); 
fprintf(fileID,'| =========                 |                                                 |\n');
fprintf(fileID,'| \\\\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox           |\n');
fprintf(fileID,'|  \\\\    /   O peration     | Version:  4.1                                   |\n');
fprintf(fileID,'|   \\\\  /    A nd           | Web:      www.OpenFOAM.org                      |\n');
fprintf(fileID,'|    \\\\/     M anipulation  |                                                 |\n');
fprintf(fileID,'\\*-----------------------------------c----------------------------------------*/ \n');
fprintf(fileID,'FoamFile\n{\n');
fprintf(fileID,'    version     2.0;\n');
fprintf(fileID,'    format      ascii;\n');
fprintf(fileID,'    class       dictionary;\n');
fprintf(fileID,'    object      blockMeshDict;\n} \n');
fprintf(fileID,'// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * // \n \n');
fprintf(fileID,'convertToMeters 1; \n \n');
fprintf(fileID,'vertices \n (\n');
fprintf(fileID,'   (%f %f 0)\r\n',coord);
fprintf(fileID,'   (%f %f 0.144)\r\n',coord);
fprintf(fileID,'); \n \n');

fprintf(fileID,'blocks \n( \n');
fprintf(fileID,'   // outer domain\n');
fprintf(fileID,'   hex (0 1 12 11 50 51 62 61) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (1 32 45 12 51 82 95 62) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (32 2 15 45 82 52 65 95) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (2 3 4 15 52 53 54 65) (%i %i 1) simpleGrading (1 1 1)\n\n',nc,nc);

fprintf(fileID,'   hex (11 12 36 35 61 62 86 85) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (35 36 13 10 85 86 63 60) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (15 4 33 42 65 54 83 92) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (42 33 5 14 92 83 55 64) (%i %i 1) simpleGrading (1 1 1)\n\n',nc,nc);

fprintf(fileID,'   hex (10 13 7 9 60 63 57 59) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (13 39 34 7 63 89 84 57) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (39 14 8 34 89 64 58 84) (%i %i 1) simpleGrading (1 1 1)\n',nc,nc);
fprintf(fileID,'   hex (14 5 6 8 64 55 56 58) (%i %i 1) simpleGrading (1 1 1)\n\n',nc,nc);

fprintf(fileID,'   //cylinder 1\n');
fprintf(fileID,'   hex (36 19 21 13 86 69 71 63) (%i %i 1) simpleGrading (%f 1 1)\n',nr,nc,1/g);
fprintf(fileID,'   hex (21 18 39 13 71 68 89 63) (%i %i 1) simpleGrading (1 %f 1)\n',nc,nr,g);
fprintf(fileID,'   hex (18 24 14 39 68 74 64 89) (%i %i 1) simpleGrading (1 %f 1)\n',nc,nr,g);
fprintf(fileID,'   hex (24 17 42 14 74 67 92 64) (%i %i 1) simpleGrading (1 %f 1)\n\n',nc,nr,g);

fprintf(fileID,'   hex (12 27 19 36 62 77 69 86) (%i %i 1) simpleGrading (%f 1 1)\n',nr,nc,1/g);
fprintf(fileID,'   hex (12 45 16 27 62 95 66 77) (%i %i 1) simpleGrading (1 %f 1)\n',nc,nr,1/g);
fprintf(fileID,'   hex (45 15 30 16 95 65 80 66) (%i %i 1) simpleGrading (1 %f 1)\n',nc,nr,1/g);
fprintf(fileID,'   hex (15 42 17 30 65 92 67 80) (%i %i 1) simpleGrading (1 %f 1)\n\n',nc,nr,1/g);

fprintf(fileID,');\n\n');

fprintf(fileID,'edges \n (\n');
fprintf(fileID,'   arc 19 21 (%f %f 0)\r\n', x(21), y(21));
fprintf(fileID,'   arc 21 18 (%f %f 0)\r\n', x(23), y(23));
fprintf(fileID,'   arc 18 24 (%f %f 0)\r\n', x(24), y(24));
fprintf(fileID,'   arc 24 17 (%f %f 0)\r\n', x(26), y(26));
fprintf(fileID,'   arc 17 30 (%f %f 0)\r\n', x(32), y(32));
fprintf(fileID,'   arc 30 16 (%f %f 0)\r\n', x(30), y(30));
fprintf(fileID,'   arc 16 27 (%f %f 0)\r\n', x(29), y(29));
fprintf(fileID,'   arc 27 19 (%f %f 0)\r\n', x(27), y(27));

fprintf(fileID,'   arc 69 71 (%f %f %f)\r\n', x(21), y(21), d);
fprintf(fileID,'   arc 71 68 (%f %f %f)\r\n', x(23), y(23), d);
fprintf(fileID,'   arc 68 74 (%f %f %f)\r\n', x(24), y(24), d);
fprintf(fileID,'   arc 74 67 (%f %f %f)\r\n', x(26), y(26), d);
fprintf(fileID,'   arc 67 80 (%f %f %f)\r\n', x(32), y(32), d);
fprintf(fileID,'   arc 80 66 (%f %f %f)\r\n', x(30), y(30), d);
fprintf(fileID,'   arc 66 77 (%f %f %f)\r\n', x(29), y(29), d);
fprintf(fileID,'   arc 77 69 (%f %f %f)\r\n', x(27), y(27),d);

fprintf(fileID,'   arc 36 13 (%f %f 0)\r\n', x(38), y(38));
fprintf(fileID,'   arc 13 39 (%f %f 0)\r\n', x(39), y(39));
fprintf(fileID,'   arc 39 14 (%f %f 0)\r\n', x(41), y(41));
fprintf(fileID,'   arc 14 42 (%f %f 0)\r\n', x(42), y(42));
fprintf(fileID,'   arc 42 15 (%f %f 0)\r\n', x(44), y(44));
fprintf(fileID,'   arc 15 45 (%f %f 0)\r\n', x(45), y(45));
fprintf(fileID,'   arc 45 12 (%f %f 0)\r\n', x(47), y(47));
fprintf(fileID,'   arc 12 36 (%f %f 0)\r\n', x(48), y(48));

fprintf(fileID,'   arc 86 63 (%f %f %f)\r\n', x(38), y(38), d);
fprintf(fileID,'   arc 63 89 (%f %f %f)\r\n', x(39), y(39), d);
fprintf(fileID,'   arc 89 64 (%f %f %f)\r\n', x(41), y(41), d);
fprintf(fileID,'   arc 64 92 (%f %f %f)\r\n', x(42), y(42), d);
fprintf(fileID,'   arc 92 65 (%f %f %f)\r\n', x(44), y(44), d);
fprintf(fileID,'   arc 65 95 (%f %f %f)\r\n', x(45), y(45), d);
fprintf(fileID,'   arc 95 62 (%f %f %f)\r\n', x(47), y(47), d);
fprintf(fileID,'   arc 62 86 (%f %f %f)\r\n', x(48), y(48), d);

fprintf(fileID,');\n\n');
 
fprintf(fileID,'boundary \n ( \n');

fprintf(fileID,'   top \n   {\n');
fprintf(fileID,'     type symmetryPlane; \n');
fprintf(fileID,'     faces \n     (\n');
fprintf(fileID,'            (9 59 57 7)\n');
fprintf(fileID,'            (7 57 84 34)\n');
fprintf(fileID,'            (34 84 58 8)\n');
fprintf(fileID,'            (8 58 56 6)\n     ); \n   }\n \n');

fprintf(fileID,'   bottom \n   {\n');
fprintf(fileID,'     type symmetryPlane; \n');
fprintf(fileID,'     faces \n     (\n');
fprintf(fileID,'            (2 52 53 3)\n');
fprintf(fileID,'            (32 82 52 2)\n');
fprintf(fileID,'            (32 82 51 1)\n');
fprintf(fileID,'            (1 51 50 0) \n     ); \n   }\n \n');

fprintf(fileID,'   inlet \n   {\n');
fprintf(fileID,'     type patch; \n');
fprintf(fileID,'     faces \n     (\n');
fprintf(fileID,'            (0 50 61 11)\n');
fprintf(fileID,'            (11 61 85 35)\n');
fprintf(fileID,'            (35 85 60 10)\n');
fprintf(fileID,'            (10 60 59 9) \n     ); \n   }\n \n');

fprintf(fileID,'   outlet \n   {\n');
fprintf(fileID,'     type patch; \n');
fprintf(fileID,'     faces \n     (\n');
fprintf(fileID,'            (6 56 55 5)\n');
fprintf(fileID,'            (5 55 83 33)\n');
fprintf(fileID,'            (33 83 54 4)\n');
fprintf(fileID,'            (4 54 53 3) \n     ); \n   }\n \n');

fprintf(fileID,'   cylinder \n   {\n');
fprintf(fileID,'     type wall; \n');
fprintf(fileID,'     faces \n     (\n');
fprintf(fileID,'            (19 21 69 71)\n');
fprintf(fileID,'            (21 18 71 68)\n');
fprintf(fileID,'            (18 24 68 74)\n');
fprintf(fileID,'            (24 17 74 67)\n');
fprintf(fileID,'            (17 30 67 80)\n');
fprintf(fileID,'            (30 16 80 66)\n');
fprintf(fileID,'            (16 27 66 77)\n');
fprintf(fileID,'            (27 19 77 69) \n     ); \n   }\n \n); \n\n');

fprintf(fileID,'mergePatchPairs \n(\n);\n');
